| garciadeblas | 8d8cd99 | 2024-05-21 16:04:14 +0200 | [diff] [blame] | 1 | #!/bin/bash |
| 2 | ####################################################################################### |
| 3 | # Copyright ETSI Contributors and Others. |
| 4 | # |
| 5 | # Licensed under the Apache License, Version 2.0 (the "License"); |
| 6 | # you may not use this file except in compliance with the License. |
| 7 | # You may obtain a copy of the License at |
| 8 | # |
| 9 | # http://www.apache.org/licenses/LICENSE-2.0 |
| 10 | # |
| 11 | # Unless required by applicable law or agreed to in writing, software |
| 12 | # distributed under the License is distributed on an "AS IS" BASIS, |
| 13 | # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or |
| 14 | # implied. |
| 15 | # See the License for the specific language governing permissions and |
| 16 | # limitations under the License. |
| 17 | ####################################################################################### |
| 18 | |
| garciadeblas | 3f37a3f | 2024-08-21 13:07:57 +0200 | [diff] [blame] | 19 | set -ex |
| garciadeblas | 8d8cd99 | 2024-05-21 16:04:14 +0200 | [diff] [blame] | 20 | |
| 21 | # Wrapper function for raw calls to Gitea API |
| 22 | |
| 23 | HERE=$(dirname "$(readlink --canonicalize "$BASH_SOURCE")") |
| 24 | . "$HERE/../library/functions.sh" |
| garciadeblas | 3b7b55c | 2024-09-19 12:39:07 +0200 | [diff] [blame] | 25 | . "$HERE/../library/trap.sh" |
| garciadeblas | de0c288 | 2024-09-10 18:10:53 +0200 | [diff] [blame] | 26 | . "$HERE/../library/helpers.sh" |
| garciadeblas | 8d8cd99 | 2024-05-21 16:04:14 +0200 | [diff] [blame] | 27 | |
| 28 | SERVER_URL=$1 |
| 29 | TOKEN=$2 |
| 30 | VERB=$3 |
| 31 | URI=$4 |
| 32 | DATA=$5 |
| 33 | |
| garciadeblas | de0c288 | 2024-09-10 18:10:53 +0200 | [diff] [blame] | 34 | function gitea_api_operation() { |
| 35 | if [ -z "$DATA" ]; then |
| 36 | kubectl exec statefulset/gitea --container=gitea --namespace=gitea --quiet -- \ |
| 37 | curl --silent --fail \ |
| 38 | "${SERVER_URL}/api/v1/${URI}" \ |
| 39 | --request "${VERB}" \ |
| 40 | --header "Authorization: token ${TOKEN}" \ |
| 41 | --header 'Accept: application/json' |
| 42 | else |
| 43 | kubectl exec statefulset/gitea --container=gitea --namespace=gitea --quiet -- \ |
| 44 | curl --silent --fail \ |
| 45 | --request "$VERB" \ |
| 46 | "${SERVER_URL}/api/v1/${URI}" \ |
| 47 | --header "Authorization: token ${TOKEN}" \ |
| 48 | --header 'Accept: application/json' \ |
| 49 | --header 'Content-Type: application/json' \ |
| 50 | --data "${DATA}" |
| 51 | fi |
| 52 | } |
| 53 | |
| garciadeblas | a14af71 | 2024-09-19 12:41:19 +0200 | [diff] [blame] | 54 | # Disable immediate exit during retries of API operations |
| 55 | set +e |
| garciadeblas | de0c288 | 2024-09-10 18:10:53 +0200 | [diff] [blame] | 56 | monitor_condition gitea_api_operation "Gitea API operation did not succeed yet...\n" 120 5 |
| 57 | RET=$? |
| garciadeblas | a14af71 | 2024-09-19 12:41:19 +0200 | [diff] [blame] | 58 | set -e |
| 59 | |
| garciadeblas | de0c288 | 2024-09-10 18:10:53 +0200 | [diff] [blame] | 60 | if [[ $RET -ne 0 ]] |
| 61 | then |
| 62 | echo -e "\nFATAL: Gitea API operation did not succeed after several retries. ABORTED.\n" |
| 63 | exit $RET |
| garciadeblas | 8d8cd99 | 2024-05-21 16:04:14 +0200 | [diff] [blame] | 64 | fi |